<?php

// Id used to identify this page within functions.
$PageID = "BORROW";

require_once "common.inc";

require_once "config.inc";
require_once "constants.inc";
require_once "db.inc";
require_once "error.inc";
require_once "layout.inc";
require_once "language.inc";
require_once "search.inc";
require_once "MARC.inc";
require_once "mgmnt.inc";

if (isset($_REQUEST['user_card_number']))
{
	if(!valid_card_number($_REQUEST['user_card_number']))
	{
     	$error = $langText['ERROR_INVALID_CARD'];
		unset($_REQUEST['stage']);
	}

	elseif(is_last_char($_REQUEST['user_card_number'], $config['card_number_suffix']))
		$_REQUEST['user_card_number'] = chop_last($_REQUEST['user_card_number']);
}

if(isset($_REQUEST['stage']) && $_REQUEST['stage'] == 2 && isset($_REQUEST['book_id']) && $_REQUEST['book_id'] == "")
{
	if(isset($_REQUEST['old_ids']) && $_REQUEST['old_ids'] != "")
	{
		$success = 1;
		$message = '';
		$borrowed_books = '';
		$books = split(",", $_REQUEST['old_ids']);

		if($config['borrow_max'] == 1) {
			$borrow_max = $config['borrow_max_number'];
		} else {
			$borrow_max = 100;
		}

		if(count($books) > $borrow_max) {
			error("session violation");
		}

		foreach ($books as $id)
		{
			$res = mysql_query("SELECT * FROM reservations WHERE reserve_book_id=".$id);
			$borrowed = mysql_fetch_array(mysql_query("SELECT * FROM borrowed WHERE borrowed_book_id=".$id));
			$row = mysql_fetch_array($res);

			if(!mysql_num_rows(mysql_query("SELECT * FROM borrowed WHERE borrowed_book_id=".$id." && borrowed_user_id!=".$_REQUEST['user_id'])) && (!mysql_num_rows($res) || $row['reserve_user_id'] == $_REQUEST['user_id']))
			{
				if(mysql_num_rows($res))
				{
					mysql_query("DELETE FROM reservations WHERE reserve_book_id=".$id);
					mysql_query("UPDATE books SET book_reserved=0 WHERE book_id=".$id);
				}
				if(empty($borrowed))
				{
					mysql_query("INSERT INTO borrowed SET borrowed_book_id=".$id.", borrowed_user_id=".$_REQUEST['user_id'].", borrowed_date=NOW()");
					if(!mysql_affected_rows())
						$success = 0;

					mysql_query("UPDATE books SET book_borrowed=1, book_borrow_count=book_borrow_count+1 WHERE book_id=".$id);
					if(!mysql_affected_rows())
						$success = 0;
				}
				else
				{
					mysql_query("UPDATE borrowed SET borrowed_date=NOW(), borrowed_time=1 WHERE borrowed_book_id=".$id);
					if(!mysql_affected_rows())
						$success = 0;
				}
			}
			else {
				$success = 0;
				$message = 'ERROR_BOOK_BORROWED';
				$status = 'error';
			}
		}

		if($success == 1) {
			$message = 'BORROW_SUCCESS';
			$status = 'ok';
		}
		elseif ($message == '') {
			$message = 'ERROR_BORROW';
			$status = 'error';
		}
	}
	else {
		$message = 'ERROR_NO_BOOKS_TO_BORROW';
		$status = 'error';
	}

	if(can_view_borrowed($_REQUEST['user_id']))
	{
		//print "<script language='javascript'>location.href='view_borrowed_books.php?id=".$_REQUEST['id']."&auth=".$_REQUEST['auth']."&stage=2&user_card_number=".format_card_number($_REQUEST['user_card_number'])."&from=borrow&status=".$status."&message=".$message."'</script>";
		header("Location: view_borrowed_books.php?id=" . $_REQUEST['id'] . "&auth=" . $_REQUEST['auth'] . "&stage=2&user_card_number=" . format_card_number($_REQUEST['user_card_number']) . "&user_id=" . $_REQUEST['user_id'] . "&old_ids=" . $_REQUEST['old_ids'] . "&from=borrow&status=" . $status . "&message=" . $message);
	}

	unset($_REQUEST['stage']);
}

$onLoad = "if(document.enter_card) document.enter_card.user_card_number.select(); if(document.book_borrow) document.book_borrow.book_id.select();";
layout_header(array('onload' => $onLoad));

if (isset($message) && isset($status)) {
	layout_page_title($message, $status);
}

if (!isset($_REQUEST['stage']))
{
	if(!isset($error))
		layout_page_title($langText['STEP_1']);
	else
		layout_page_title($error, 'error');
	?>

		<form name='enter_card' action='borrow.php' method='get'>
			<input type='hidden' name='id' value='<?php echo $_REQUEST['id']?>'>
			<input type='hidden' name='auth' value='<?php echo $_REQUEST['auth']?>'>
			<input type='hidden' name='stage' value='2'>

			<?php echo $langText['ENTER_CARD_NUMBER']?>:&nbsp;
			<input type='text' name='user_card_number' size='20'>&nbsp;&nbsp;
			<input type='submit' name='submit' class='button' value='<?php echo $langText['BUTTON_CONTINUE']?>'>
		</form>

	<?php
}

elseif ($_REQUEST['stage'] == 2 && (!isset($_REQUEST['book_id']) || $_REQUEST['book_id'] != ""))
{
	$user = mysql_fetch_array(mysql_query("SELECT user_id, user_given_names, user_surname FROM users WHERE user_card_number=".$_REQUEST['user_card_number']));

	layout_page_title(format_user_real_name($user));

	?>

		<form name='book_borrow' action='borrow.php' method='get'>
			<input type='hidden' name='id' value='<?php echo $_REQUEST['id']?>'>
			<input type='hidden' name='auth' value='<?php echo $_REQUEST['auth']?>'>
			<input type='hidden' name='user_card_number' value='<?php echo $_REQUEST['user_card_number']?>'>
			<input type='hidden' name='user_id' value='<?php echo $user['user_id']?>'>
			<input type='hidden' name='stage' value='2'>

			<?php echo $langText['ENTER_BOOK_ID']?>:&nbsp;
			<input type='text' name='book_id' size=20>&nbsp;&nbsp;
			<input type='submit' name='submit' class='button' value='<?php echo $langText['BUTTON_BORROW']?>'>

		<br />
		<br />

	<?php

	if(isset($_REQUEST['book_id']) && !is_book($_REQUEST['book_id']))
	{
		layout_page_info($langText['ERROR_NOT_BOOK_ID'], 'error', TRUE);
		unset($_REQUEST['book_id']);
	}

	// Chop off the book_id suffix
	if(isset($_REQUEST['book_id']))
		$_REQUEST['book_id'] = chop_last($_REQUEST['book_id']);

	$ids = "";
	$books = array();
	$content = array();
	$book_ids = array();
	$book_ids_only = array();
	$old_rows = array();
	$i = 0;
	//$ii = 1;
	$hits_inc = 0;
	$table_header = 0;

	if($config['borrow_max'] == 1) {
		$borrow_max = $config['borrow_max_number'];
	} else {
		$borrow_max = 100;
	}


	if(isset($_REQUEST['book_id']) || isset($_REQUEST['old_ids']))
	{
		$headers = array($langText['BOOK_ID']);

		foreach ($MARC_display_in_list as $value)
		{
			array_push($headers, $langText[strtoupper($MARC_config[$value])]);
		}
	}

	if(isset($_REQUEST['old_ids']) && $_REQUEST['old_ids'] != "")
	{
		list($book_list, $book_ids_only, $books) = zebra_list_syntax($_REQUEST['old_ids']);

		$_REQUEST['element'] = "F";

		if(count($books) > 1)
			list($YAZ_items, $hits) = search("001", $book_list, "1", count($books), "", "", "@or");
		else
			list($YAZ_items, $hits) = search("001", $book_list, "1");

		if($hits)
		{
			$i = 0;
			while($i < count($YAZ_items) && $i < $borrow_max)
			{
				parseMARC($YAZ_items[$i]);
				$row = createMARCRow(return_with_format_syntax($MARC_display_in_list));
				$rows[book_control_number()] = $row;

				$i++;
			}

			$i = 0;
			while($i < count($books) && $i < $borrow_max)
			{
				$content = array(format_book_id($books[$i]));
				$row = array();

				$row = $rows[$book_ids_only[$i]];

				if(!$table_header) {
					layout_table_header($headers);
					$table_header = 1;
				}

				while(list($key, $value) = each($row))
				{
					array_push($content, $row[$key]);
				}

				layout_table_row($content);

				$i++;
			}
		}
	}

	if(count($books) >= $borrow_max) {
		layout_page_info($langText['MAX_BORROWED_AT_ONCE']." ".$borrow_max, 'error');
	}
	elseif(isset($_REQUEST['book_id']) && $_REQUEST['book_id'] != "" && !in_array($_REQUEST['book_id'], $books))
	{
		$sql_row = mysql_fetch_array(mysql_query(	"SELECT book_control_number, book_borrowed, book_reserved
													FROM books
													WHERE book_id=".$_REQUEST['book_id']));

		$borrowed = mysql_fetch_array(mysql_query("SELECT * FROM borrowed WHERE borrowed_book_id=".$_REQUEST['book_id']));

		$reserved = mysql_fetch_array(mysql_query("SELECT * FROM reservations WHERE reserve_book_id=".$_REQUEST['book_id']));

		if(empty($borrowed) || $borrowed['borrowed_user_id'] == $_REQUEST['user_id'])
		{
			if($sql_row['book_reserved'] == 0 || (isset($reserved['reserve_user_id']) && $reserved['reserve_user_id'] == $user['user_id']))
			{
				$_REQUEST['element'] = "F";
				list($YAZ_items, $hits) = search("001", format_control_number($sql_row['book_control_number']), "1");

				if($hits)
				{
					if(isset($_REQUEST['old_ids']))
						$_REQUEST['old_ids'] = $_REQUEST['old_ids'].",".$_REQUEST['book_id'];
					else
						$_REQUEST['old_ids'] = $_REQUEST['book_id'];

					$content = array(format_book_id($_REQUEST['book_id']));
					$row = array();

					parseMARC($YAZ_items[0]);
					$row = createMARCRow(return_with_format_syntax($MARC_display_in_list));
					$old_rows[format_control_number($sql_row['book_control_number'])] = $row;

					if(!$table_header) {
						layout_table_header($headers);
						$table_header = 1;
					}

					while(list($key, $value) = each($row))
					{
						array_push($content, $row[$key]);
					}

					layout_table_row($content);
				}
				else
				{
					layout_page_info($langText['ERROR_NO_BOOK'], 'error', TRUE);
				}
			}
			else
			{
				layout_page_info($langText['ERROR_BOOK_RESERVED'], 'error', TRUE);
			}
		}
		else
		{
			layout_page_info($langText['ERROR_BOOK_BORROWED'], 'error', TRUE);
		}
	}

	if(!empty($headers) && $table_header) {
		layout_page_info($langText['BOOK_LIST'], '', TRUE);
		layout_table_footer();
	}

	/*
	print "OLD:";
	print_r($old_rows);
	print "<br>";
	*/

	if(isset($_REQUEST['old_ids'])) {
		print "<input type='hidden' name='old_ids' value='".$_REQUEST['old_ids']."'>";
	}

	print "</form>";
}

layout_footer();

?>
