<?php

// Id used to identify this page within functions.
$PageID = "GROUP_MANAGEMENT";

require_once "common.inc";

require_once "config.inc";
require_once "constants.inc";
require_once "db.inc";
require_once "error.inc";
require_once "layout.inc";
require_once "mgmnt.inc";
require_once "language.inc";
require_once "MARC.inc";
require_once "search.inc";

layout_header();

if(isset($_REQUEST['delete_id']) && is_numeric($_REQUEST['delete_id']))
{
	if($_REQUEST['delete_id'] == USER_ID)
	{
		error("session violation");
		exit;
	}

	if(check_priv("ADMIN"))
	{
		$res1 = mysql_query("DELETE FROM linkage WHERE user_id=".$_REQUEST['delete_id']);
		$res2 = mysql_query("DELETE FROM users WHERE user_id=" . $_REQUEST['delete_id']);

		if(mysql_affected_rows())
		{
                writeLog("User deleted: " . $_REQUEST['delete_id'], $_REQUEST['id'], USER_ID);
                layout_page_title($langText['USER_DELETE_SUCCESSFUL'], 'ok');
        }
        else {
			layout_page_title($langText['ERROR_USER_DELETE_FAIL'], 'error');
		}
	}
	else
		error("session violation");
}

if(isset($_REQUEST['delete_group']))
{
	if(!is_group_manager($_REQUEST['delete_group']))
	{
		error("session violation");
		exit;
	}

	mysql_query("DELETE FROM groups WHERE group_id=".$_REQUEST['delete_group']);
	mysql_query("DELETE FROM linkage WHERE group_id=".$_REQUEST['delete_group']);

	if(mysql_affected_rows())
		layout_page_title($langText['GROUP_DELETE_SUCCESS'], 'ok');
	else
		layout_page_title($langText['ERROR_GROUP_DELETE'], 'error');
}

if(isset($_REQUEST['attach_id']) && is_numeric($_REQUEST['attach_id']))
{
	if(isset($_REQUEST['group_id']) && is_numeric($_REQUEST['group_id']))
	{
		if(attaching_allowed($_REQUEST['attach_id'], $_REQUEST['group_id']))
		{
			mysql_query(	"INSERT INTO linkage SET
							user_id=".$_REQUEST['attach_id'].",
							group_id=".$_REQUEST['group_id'].",
							group_manager=0,
							visible=1,
							view_borrowed=0");
			
			if(mysql_affected_rows())
				print layout_page_title($langText['ATTACH_SUCCESS'], 'ok');
			else
				print layout_page_title($langText['ERROR_ATTACH'], 'error');
		}
		else
			error("session violation");
	}
	else
		error("url dismatch");
}

if(isset($_REQUEST['detach_id']) && is_numeric($_REQUEST['detach_id']))
{
	if(isset($_REQUEST['group_id']) && is_numeric($_REQUEST['group_id']))
	{
		if(my_subordinate($_REQUEST['detach_id']))
		{
			mysql_query(	"DELETE FROM linkage
							WHERE user_id=".$_REQUEST['detach_id']."
							AND group_id=".$_REQUEST['group_id']);
			
			if(mysql_affected_rows())
				print layout_page_title($langText['DETACH_SUCCESS'], 'ok');
			else
				print layout_page_title($langText['ERROR_DETACH'], 'error');
		}
		else
			error("session violation");
	}
	else
		error("url dismatch");
}

if(isset($_REQUEST['update']) && isset($_REQUEST['group_id']) && is_numeric($_REQUEST['group_id']))
{
	if(is_group_manager($_REQUEST['group_id']))
	{
        if(isset($_REQUEST['group_name']) && isset($_REQUEST['group_description']))
		{
			if(isset($_REQUEST['group_view_borrowed']) && $_REQUEST['group_view_borrowed'] == "on")
				$group_view_borrowed = 1;
			else
				$group_view_borrowed = 0;

			if($group_view_borrowed == 0)
				mysql_query("UPDATE linkage SET view_borrowed=0 WHERE group_id=".$_REQUEST['group_id']);

			$res = mysql_query("UPDATE groups
						SET group_name='".$_REQUEST['group_name']."',
						group_description='".$_REQUEST['group_description']."',
						group_view_borrowed=".$group_view_borrowed."
						WHERE group_id=".$_REQUEST['group_id']);
		}
		else {
			error("url dismatch");
		}

		foreach($_REQUEST as $key => $value)
		{
			$group_manager = 0;
			$view_borrowed = 0;
			$visible = 0;

			if(preg_match("/^user_id_/", $key))
			{
                $temp = split("_", $key);
				$current_user_id = $temp[2];

				if(array_key_exists("group_manager_".$current_user_id, $_REQUEST) && $_REQUEST["group_manager_".$current_user_id]) {
					$group_manager = 1;
				}

				if(array_key_exists("view_borrowed_".$current_user_id, $_REQUEST) && $_REQUEST["view_borrowed_".$current_user_id] && $group_view_borrowed) {
					$view_borrowed = 1;
				}

				if(array_key_exists("visible_".$current_user_id, $_REQUEST) && $_REQUEST["visible_".$current_user_id]) {
					$visible = 1;
				}

				if(check_priv("ADMIN")) {
					mysql_query("UPDATE linkage SET group_manager=".$group_manager.", view_borrowed=".$view_borrowed.", visible=".$visible." WHERE user_id=".$current_user_id." AND group_id=".$_REQUEST['group_id']);
				} elseif(check_priv("POWER")) {
					mysql_query("UPDATE linkage SET group_manager=".$group_manager.", view_borrowed=".$view_borrowed." WHERE user_id=".$current_user_id." AND group_id=".$_REQUEST['group_id']);
				}
			}
		}

		if(mysql_affected_rows() != -1) {
			layout_page_title($langText['GROUP_UPDATE_SUCCESS'], 'ok');
		} else {
			layout_page_title($langText['ERROR_GROUP_UPDATE'], 'error');
		}

		$_REQUEST[$_REQUEST['group_id']] = 'expand';

	}
	else
	{
		error("session violation");
	}
}


if(!isset($_REQUEST['edit_id']) || is_numeric($_REQUEST['edit_id']))
{
	if(isset($_REQUEST['edit_id']) && is_numeric($_REQUEST['edit_id']))
		$edit_id = $_REQUEST['edit_id'];
	else
		$edit_id = "";
	?>
	<script language='JavaScript'>

	function detach_user(delid, group_id, real_name)
	{
		var msg = "<?php echo umlaut_str($langText['CONFIRM_DETACH_USER']) ?> " + real_name + "?";

		if (confirm(msg))
		    location.replace("group_management.php?id=<?php echo $_REQUEST['id']?>&auth=<?php echo $_REQUEST['auth']?>&" + group_id + "=expand&detach_id=" + delid + "&group_id=" + group_id);
	}

	function del_group(delid, group_name, group_description)
	{
		var msg = "<?php echo umlaut_str($langText['CONFIRM_DELETE_GROUP']) ?> '" + group_name + " - " + group_description + "'?";

		if (confirm(msg))
		    location.replace("group_management.php?id=<?php echo $_REQUEST['id']?>&auth=<?php echo $_REQUEST['auth']?>&delete_group=" + delid);
	}

	function del_user(delid, real_name)
	{
		var msg = "<?php echo umlaut_str($langText['CONFIRM_DELETE_USER']) ?> " + real_name + "?";

		if (confirm(msg))
		    location.replace("group_management.php?id=<?php echo $_REQUEST['id']?>&auth=<?php echo $_REQUEST['auth']?>&delete_id=" + delid + "&all");
	}

	</script>

	<?php

	layout_page_title($langText['HEADER']);

	if (empty ($_REQUEST['order_by']))
	{
		$_REQUEST['order_by'] = "user_surname";
		$_REQUEST['order_dir'] = "ASC";
	}

	$pre_result = mysql_query(	"SELECT *
								FROM linkage, groups
								WHERE groups.group_id=linkage.group_id
								AND linkage.user_id=".USER_ID."
								AND linkage.group_manager=1
								ORDER BY groups.group_name ASC");

	//$headers = array("", "", "", $langText['USER_ID'], "&nbsp;", $langText['USER_NAME'], "&nbsp;", $langText['USER_REALNAME'], "&nbsp;", $langText['USER_EMAIL'], "&nbsp;", "A", "B", "C", "D", "E", "F", "G", "H");
	//$options = array("", "", "", "width=30", "width=100", "width=300", "width=200", "width=15", "width=15", "width=15", "width=15", "width=15", "width=15", "width=15", "width=15");

	// Allows the system to list expanded groups first.
	$group_rows = array();
	foreach($_REQUEST as $key => $value)
	{
		if($value == "expand") {
			$expanded = $key;
		}
		if($key == "edit_id"){
			$edit_id = $value;
		}
	}
	while($row = mysql_fetch_array($pre_result))
	{
        if(isset($expanded) && $row['group_id'] == $expanded) {
			$group_rows = array_merge(array($row), $group_rows);
		} elseif (isset($edit_id) && $row['group_id'] == $edit_id) {
			$group_rows = array_merge(array($row), $group_rows);
		}
        else
			array_push($group_rows, $row);
	}

	$count = 0; //for distinguishing forms
	foreach($group_rows as $row)
	{
		/*$base_url = preg_replace("/\&(detach|group)_id\=\d/", "", getenv('REQUEST_URI'));
		$base_url = preg_replace("/\&(group_manager_|view_borrowed_)\d\=on/", "", $base_url);
		$base_url = preg_replace("/\&update\=Update/", "", $base_url);
		*/

		$count++;

		if($row['group_id'] != $edit_id)
		{
			//$result = mysql_query("SELECT group_name, group_description, COUNT(user_id) AS count FROM groups, linkage WHERE groups.group_id=".$pre_row['group_id']."GROUP BY groups.group_id");
			//$row = mysql_fetch_array($result);

			if(isset($_REQUEST[$row['group_id']]) && $_REQUEST[$row['group_id']] == "expand") {
				$contract_expand = "<a href='group_management.php?id=".$_REQUEST['id']."&auth=".$_REQUEST['auth']."&".$row['group_id']."=contract'>".layout_insertImg('icon_sort_desc.png')."</a>";
			}
			else {
				$contract_expand = "<a href='group_management.php?id=".$_REQUEST['id']."&auth=".$_REQUEST['auth']."&".$row['group_id']."=expand'>".layout_insertImg('icon_sort_asc.png')."</a>";
			}

			$headers = array();
			array_push(	$headers,
							"<a href='group_management.php?id=".$_REQUEST['id']."&auth=".$_REQUEST['auth']."&edit_id=" . $row['group_id'] . "'>" . layout_insertImg('icon_edit.png') . "</a>"
							. layout_blankImg(5)
							. "<a href='javascript:del_group(" . $row['group_id'] . ", \"" . $row['group_name'] . "\", \"" . $row['group_description'] . "\")'>" . layout_insertImg('icon_delete.png') . "</a>"
			);

			array_push($headers, $row['group_name'], $contract_expand . "&nbsp;");

			layout_table_header($headers, array('width="1%"', 'width="1%"', 'align="right" colspan="4"'), '', 'width="450"');
			layout_table_row(array("&nbsp;", $langText['GROUP_DESCRIPTION'].":", $row['group_description'], "&nbsp;"), 1, array('', 'valign="top"', 'colspan="2"', ''));

			$content = array();
			$current_group_id = $row['group_id'];
			$current_group_view_borrowed_restriction = $row['group_view_borrowed'];

			if(isset($_REQUEST[$row['group_id']]) && $_REQUEST[$row['group_id']] == "expand")
			{
				$show_only_visible = "AND linkage.visible=1";
				if(check_priv("ADMIN")) {
					$show_only_visible = "";
				}

				$u_res = mysql_query(	"SELECT users.user_card_number, users.user_given_names, users.user_surname, users.user_id, linkage.view_borrowed, linkage.group_manager, linkage.visible
										FROM linkage, users
										WHERE users.user_id=linkage.user_id
										AND linkage.group_id=".$row['group_id']."
										".$show_only_visible."
										ORDER BY linkage.visible DESC, linkage.group_manager DESC, users.user_surname ASC"
										);

				$user_rows = array();
				$group_managers = array();

				while($u_row = mysql_fetch_array($u_res))
				{
					if($u_row['group_manager'] == 1)
						array_push($group_managers, format_user_real_name($u_row));

					array_push($user_rows, $u_row);
				}

				if(isset($row['group_view_borrowed']) && $row['group_view_borrowed'] == 0) {
					$view_borrowed_restriction = "<font class='red'>".$langText['NO']."</font>";
				} else {
					$view_borrowed_restriction = $langText['YES'];
				}

				layout_table_row(array("&nbsp;", $langText['GROUP_USER_COUNT'].":", mysql_num_rows($u_res), "&nbsp;"), 'auto', array('', 'valign="top"', 'colspan="2"'));
				layout_table_row(array("&nbsp;", $langText['GROUP_MANAGERS'].":", join(", ",$group_managers), "&nbsp;"), 'auto', array('', 'valign="top"', 'colspan="2"'));
				layout_table_row(array("&nbsp;", $langText['VIEW_BORROWED_RESTRICTION'].":", $view_borrowed_restriction, "&nbsp;"), 'auto', array('', 'valign="top"', 'colspan="2"'));

				if(check_priv("ADMIN")) {
					$visible_header = "<b>".$langText['USER_VISIBLE']."</b>";
				} else {
					$visible_header = "&nbsp;";
				}

				layout_table_row(array(	"&nbsp;",
										"<b>".$langText['USER_TYPE']."</b>",
										"<b>".$langText['USER_NAME']."</b>",
										"<b>".$langText['USER_TASK']."</b>",
										"<b>".$langText['USER_VIEW_BORROWED']."</b>",
										$visible_header), 3, 'nowrap', 1);

				foreach ($user_rows as $row)
				{
					$content = array();
					$group_task = "<font class='gray'>".$langText['USER_TASK_NONE']."</font>";
					$view_borrowed = "<font class='red'>".$langText['NO']."</font>";

					if(check_priv("ADMIN"))
					{
						$visible = "<font class='red'>".$langText['NO']."</font>";
						if($row['visible'] == 1) {
							$visible = "<font class='green'>".$langText['YES']."</font>";
						}
					} else {
						$visible = "&nbsp;";
					}


					if($row['user_id'] != USER_ID && my_subordinate($row['user_id']))
					{
						$edit_delete = 	"<a href='management.php?id=" . $_REQUEST['id'] . "&auth=" . $_REQUEST['auth'] . "&user_id=" . $row['user_id'] . "'>" . layout_insertImg('icon_edit.png') . "</a>"
										. "&nbsp;"
										. "<a href='javascript:detach_user(" . $row['user_id'] . ", " . $current_group_id . ", \"" . format_user_real_name($row) . "\")'>" . layout_insertImg('icon_delete.png') . "</a>"
										. "";
					}
					else
					{
						$edit_delete = '&nbsp;';
					}

					if(can_view_borrowed($row['user_id']) && $row['user_id'] != USER_ID)
					{
						$viewb = "&nbsp;<a href='view_borrowed_books.php?id=".$_REQUEST['id']."&auth=".$_REQUEST['auth']."&user_card_number=".$row['user_card_number']."&stage=2'>".layout_insertImg("icon_view_borrowed.png")."</a>";
					}
					else {
						$viewb = '';
					}

					if(my_subordinate($row['user_id']) && $row['user_id'] != USER_ID)
					{
						$user_move = "&nbsp;<a href='user_move.php?id=".$_REQUEST['id']."&auth=".$_REQUEST['auth']."&stage=2&user_id=".$row['user_card_number']."'>".layout_insertImg('icon_user_move.png')."</a>";
					}
					else {
						$user_move = '';
					}

					array_push($content, $edit_delete . $viewb . $user_move);

					if(check_priv("ADMIN", $row['user_id'])) {
						$type = "<font class='red'>ADMIN</font>";
					} elseif(check_priv("POWER", $row['user_id'])) {
						$type = "<font class='green'>POWER</font>";
					} else {
						$type = "NORMAL";
					}


					if($row['group_manager'] == 1) {
						$group_task = "<font class='green'>".$langText['USER_TASK_GROUP_MANAGER']."</font>";
					}

					if($row['view_borrowed'] == 1) {
						$view_borrowed = "<font class='green'>".$langText['YES']."</font>";
					}

					array_push($content, $type, format_user_real_name($row), $group_task, $view_borrowed, $visible);

					layout_table_row($content, 'auto', 'nowrap', 1);
				}
			}

			// Print-user-list button
            $print_user_list = "<form name='print_user_list$count' action='perl/PDF.pl' method='get'>
							    	<input type='hidden' name='id' value='".$_REQUEST['id']."'>
									<input type='hidden' name='auth' value='".$_REQUEST['auth']."'>
									<input type='hidden' name='perl_id' value='".$config['perl_id']."'>
									<input type='hidden' name='perl_auth' value='".md5($config['perl_auth'])."'>
									<input type='hidden' name='landscape' value='false'>
									<input type='hidden' name='from_url' value='".get_base_url()."pdf.php?id=".$_REQUEST['id']."&auth=".$_REQUEST['auth']."&page=user_list&group_id=".$current_group_id."'>
									<a href='javascript:document.print_user_list$count.submit();' class='no-underline'>"
									. layout_insertImg('icon_print.png', '', '', '', '', 'absbottom') . "&nbsp;" . $langText['USER_LIST']
									. "</a>
								</form>";


			//Print-borrowed-books button
			if($current_group_view_borrowed_restriction)
			{
				$print_view_borrowed = 	"<form name='print_borrowed_books$count' action='perl/PDF.pl' method='get'>
											<input type='hidden' name='id' value='".$_REQUEST['id']."'>
											<input type='hidden' name='auth' value='".$_REQUEST['auth']."'>
											<input type='hidden' name='perl_id' value='".$config['perl_id']."'>
											<input type='hidden' name='perl_auth' value='".md5($config['perl_auth'])."'>
											<input type='hidden' name='from_url' value='".get_base_url()."pdf.php?id=".$_REQUEST['id']."&auth=".$_REQUEST['auth']."&page=view_borrowed&group_id=".$current_group_id."'>
											<a href='javascript:document.print_borrowed_books$count.submit();' class='no-underline'>"
											. layout_insertImg('icon_print.png', '', '', '', '', 'absbottom') . "&nbsp;" . $langText['BORROWED_BOOKS'] .
											"</a>
										</form>";
			}
			else {
				$print_view_borrowed = "";
			}

			layout_table_footer(
				"<table border='0' width='100%'>
					<tr><td>$print_user_list</td></tr>
					<tr><td>$print_view_borrowed</td></tr>
				</table>"
			);

			print '<br /><br />';
		}
		else
		{
			print "<form name='update_group' action='group_management.php' method='post'>";
			print "<input type='hidden' name='id' value='".$_REQUEST['id']."'>";
			print "<input type='hidden' name='auth' value='".$_REQUEST['auth']."'>";
			print "<input type='hidden' name='group_id' value='".$row['group_id']."'>";

			$group_id = $row['group_id'];

			$show_only_visible = "AND linkage.visible=1";
			if(check_priv("ADMIN"))
				$show_only_visible = "";

			$u_res = mysql_query(	"SELECT users.user_card_number, users.user_given_names, users.user_surname, users.user_id, linkage.view_borrowed, linkage.group_manager, linkage.visible
									FROM linkage, users
									WHERE users.user_id=linkage.user_id
									AND linkage.group_id=".$row['group_id']."
									".$show_only_visible."
									ORDER BY linkage.visible DESC, linkage.group_manager DESC, users.user_surname ASC");

			$user_rows = array();
			$group_managers = array();
			while($u_row = mysql_fetch_array($u_res))
			{
				if($u_row['group_manager'] == 1)
					array_push($group_managers, format_user_real_name($u_row));

				array_push($user_rows, $u_row);
			}

			$headers = array();
			array_push($headers, '&nbsp;', $langText['EDIT_GROUP_INFO']);
			layout_table_header($headers, array('', 'colspan="5"'));

			$view_borrowed_checked = ($row['group_view_borrowed'] == 0) ? "" : "checked";

			layout_table_row(array("&nbsp;", $langText['GROUP_NAME'].":", "<input type='text' name='group_name' size=30 value='".$row['group_name']."'>"), 'auto', array('', '', 'colspan="4"'));
			layout_table_row(array("&nbsp;", $langText['GROUP_DESCRIPTION'].":", "<input type='text' name='group_description' size=30 value='".$row['group_description']."'>"), 'auto', array('', '', 'colspan="4"'));
			layout_table_row(array("&nbsp;", $langText['GROUP_USER_COUNT'].":", mysql_num_rows($u_res)), 'auto', array('', '', 'colspan="4"'));
			layout_table_row(array("&nbsp;", $langText['GROUP_MANAGERS'].":", join(", ",$group_managers)), 'auto', array('', '', 'colspan="4"'));
			layout_table_row(array("&nbsp;", $langText['VIEW_BORROWED_RESTRICTION'].":", "<input type='checkbox' name='group_view_borrowed' ".$view_borrowed_checked.">"), 'auto', array('', '', 'colspan="4"'));

			$current_group_id = $row['group_id'];
			
			if(check_priv("ADMIN"))
				$visible_header = "<b>".$langText['USER_VISIBLE']."</b>";
			else
				$visible_header = "&nbsp;";

			layout_table_row(array(	"&nbsp;",
									"<b>".$langText['USER_TYPE']."</b>",
									"<b>".$langText['USER_NAME']."</b>",
									"<b>".$langText['USER_TASK']."</b>",
									"<b>".$langText['USER_VIEW_BORROWED']."</b>",
									$visible_header), 3);

			foreach ($user_rows as $row)
			{
				$content = array();
				$group_task = "<font class='gray'>".$langText['USER_TASK_NONE']."</font>";
				$view_borrowed = "<font class='red'>" . $langText['NO'] . "</font>";
				$visible = "<font class='red'>" . $langText['NO'] . "</font>";

				if($row['user_id'] != USER_ID && my_subordinate($row['user_id']))
				{
					$edit_delete = 	"<a href='management.php?id=" . $_REQUEST['id'] . "&auth=" . $_REQUEST['auth'] . "&user_id=" . $row['user_id'] . "'>" . layout_insertImg('icon_edit.png') . "</a>"
									. "&nbsp;"
									. "<a href='javascript:detach_user(" . $row['user_id'] . ", " . $current_group_id . ", \"" . format_user_real_name($row) . "\")'>" . layout_insertImg('icon_delete.png') . "</a>"
									. "";
				}
				else
				{
					$edit_delete = '&nbsp;';
				}

				if(can_view_borrowed($row['user_id']) && $row['user_id'] != USER_ID)
				{
					$viewb = "&nbsp;<a href='view_borrowed_books.php?id=".$_REQUEST['id']."&auth=".$_REQUEST['auth']."&user_card_number=".$row['user_card_number']."&stage=2'>".layout_insertImg("icon_view_borrowed.png")."</a>";
				}
				else {
					$viewb = '';
				}
				
				array_push($content, $edit_delete . $viewb);

				//array_push($content, "&nbsp;");

				if(check_priv("ADMIN", $row['user_id']))
					$type = "<font class='red'>ADMIN</font>";
				elseif(check_priv("POWER", $row['user_id']))
					$type = "<font class='green'>POWER</font>";
				else
					$type = "NORMAL";

				if($row['user_id'] != USER_ID && my_subordinate($row['user_id']) && can_be_group_manager($row['user_id']))
				{
					$checked = ($row['group_manager'] == 1) ? "checked" : "";
					$group_task = $langText['USER_TASK_GROUP_MANAGER'].":&nbsp;<input type='checkbox' name='group_manager_".$row['user_id']."' ".$checked.">";
				}
				elseif($row['group_manager'] == 1)
					$group_task = "<font class='green'>".$langText['USER_TASK_GROUP_MANAGER']."</font>";

				if($row['user_id'] != USER_ID && my_subordinate($row['user_id']) && check_priv("BORROWED_BOOKS", $row['user_id']) && view_borrowed_allowed($group_id))
				{
					$checked = ($row['view_borrowed'] == 1) ? "checked" : "";
					$view_borrowed = "<input type='checkbox' name='view_borrowed_".$row['user_id']."' ".$checked.">";
				}
				elseif($row['view_borrowed'] == 1)
					$view_borrowed = "<font class='green'>" . $langText['YES'] . "</font>";

				if(check_priv("ADMIN"))
				{
					if($row['user_id'] != USER_ID && my_subordinate($row['user_id']))
					{
						$checked = ($row['visible'] == 1) ? "checked" : "";
						$visible = "<input type='checkbox' name='visible_".$row['user_id']."' ".$checked.">";
					}
					elseif($row['visible'] == 1)
						$visible = "<font class='green'>" . $langText['YES'] . "</font>";
				}
				else
					$visible = "&nbsp;";

				if($row['user_id'] != USER_ID)
					print "<input type='hidden' name='user_id_".$row['user_id']."' value='".$row['user_id']."'>";
					
				array_push($content, $type, format_user_real_name($row), $group_task, $view_borrowed, $visible);

				layout_table_row($content);
			}

			// Attachable users drop-down
			$attachable_users = 	"<form name='attach_id$count' action='".getenv('REQUEST_URI')."' method='post'>
										<input type='hidden' name='group_id' value='".$current_group_id."'>
										<select name='attach_id'><option>- ".$langText['SELECT_USER']." -</option>";

				foreach(attachable_users($current_group_id) as $user) {
					$attachable_users .= 	"<option value='".$user['user_id']."'>".$user['user_surname'].", ".$user['user_given_names']."</option>";
				}

				$attachable_users .= 	"</select>
										&nbsp;
										<input type='submit' class='button' name='attach' value='".$langText['BUTTON_ATTACH']."'>
									</form>";

			layout_table_footer(
				"<input type='hidden' name='update' value='update' />
				</form>
				<table border='0' width='100%'>
				<tr><td align='left'>" .
				$attachable_users .
				"</td><td align='right'>
				<input type='button' class='button' name='cancel' value='" . $langText['BUTTON_CANCEL'] . "' onClick='location.replace(\"group_management.php?id=" . $_REQUEST['id'] . "&auth=" . $_REQUEST['auth'] . "\");'>
				&nbsp;&nbsp;
				<input type='button' class='button' name='update' value='".$langText['BUTTON_UPDATE']."' onClick='document.update_group.submit();'>
				</td></tr>
				</table>"
			);

			print "<br /><br />";
		}
	}
}

// Create list of all users of the system if user is ADMIN.
// Allows the ADMIN to remove users from the system!
if(check_priv("ADMIN") && !isset($_REQUEST['all']))
{
	print '<a href="group_management.php?id=' . $_REQUEST['id'] . '&auth=' . $_REQUEST['auth'] . '&all">';
	layout_page_info($langText['ALL_USERS_LIST'] . '&nbsp;&gt;&gt;');
	print '</a>';
}
elseif(check_priv("ADMIN") && isset($_REQUEST['all']))
{
 	$res = mysql_query("SELECT * FROM users ORDER BY user_surname");

	$headers = array(	"&nbsp;",
						$langText['USER_CARD_NUMBER'],
						$langText['USER_REAL_NAME'],
                        $langText['USER_EMAIL']
						);

	layout_page_info($langText['ALL_USERS_LIST']);

	layout_table_header($headers);

	while($row = mysql_fetch_array($res))
	{
       	$content = array();

		if($row['user_id'] != USER_ID && my_subordinate($row['user_id']))
		{
			$edit_delete = 	"<a href='management.php?id=" . $_REQUEST['id'] . "&auth=" . $_REQUEST['auth'] . "&user_id=" . $row['user_id'] . "'>" . layout_insertImg('icon_edit.png') . "</a>"
							. "&nbsp;"
							. "<a href='javascript:del_user(" . $row['user_id'] . ",\"" . format_user_real_name($row) . "\")'>" . layout_insertImg('icon_delete.png') . "</a>"
							. "";
		}
		else
		{
			$edit_delete = '&nbsp;';
		}

		if(can_view_borrowed($row['user_id']) && $row['user_id'] != USER_ID)
		{
			$viewb = "&nbsp;<a href='view_borrowed_books.php?id=".$_REQUEST['id']."&auth=".$_REQUEST['auth']."&user_card_number=".$row['user_card_number']."&stage=2'>".layout_insertImg("icon_view_borrowed.png")."</a>";
		}
		else {
			$viewb = '';
		}

		array_push($content, $edit_delete . $viewb);

        array_push($content, format_card_number($row['user_card_number']), $row['user_surname'].", ".$row['user_given_names'], $row['user_email']);
		layout_table_row($content);

	}

	layout_table_footer();
}

layout_footer();
?>
